#pragma once
#include "TsStreamEngine/TsStream.h"
#include <string>
#include <vector>

class CEpgView
{
public:
	CEpgView(void);
	~CEpgView(void);

	void SetEpgData(WORD wServiceID,struct TSEPG_PROGRAM *pstProg,int iNum)
	{
		m_wServiceID = wServiceID;
		m_pstProg = pstProg;
		m_iNum = iNum;
	};

	INT_PTR ShowModal(HINSTANCE hInst,int iResource,HWND hParentWnd);

protected:
	HWND m_hWnd;
	WORD m_wServiceID;
	struct TSEPG_PROGRAM *m_pstProg;
	int m_iNum;
	std::vector<COLORREF> m_TextColor;
	std::vector<HBRUSH> m_BackBrush;
	std::vector<std::string> m_ItemStrings;

	LRESULT EpgDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
	void OnInitDialog();

	// WindowProc(Dummy)
	static LRESULT CALLBACK _EpgDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
	{
	#pragma warning(disable: 4312)
		CEpgView* pThis=reinterpret_cast<CEpgView*>(GetWindowLongPtr(hDlg,GWL_USERDATA));
	#pragma warning(default: 4312)
		if(message==WM_INITDIALOG)
		{
			{
				pThis=(CEpgView*)lParam;
	#pragma warning(disable: 4244)
				SetWindowLongPtr(hDlg,GWL_USERDATA,reinterpret_cast<LONG_PTR>(pThis));
	#pragma warning(default: 4244)
			}
		}
		if(pThis)
		{
			return pThis->EpgDlg(hDlg,message,wParam,lParam);
		} else {
			return FALSE;
		}
	}
};
