#pragma once

#include "../lib/IB25Decoder.h"
typedef IB25Decoder* (PFCREATEB25DECORDER)(void);
typedef IB25DecoderEx* (PFCREATEB25DECORDEREX)(void);
typedef unsigned int (PFGETB25VERSION)(void);

class CB25
{
public:
	CB25(void);
	~CB25(void);

	BOOL Open(char *lpszInitStr);
	void Close();
	BOOL IsOpen();

	BOOL Initialize();
	BOOL Reset();

	BOOL IsExtendAPI();

	DWORD DataPutAndGet(BYTE *pSrcBuf, DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize);
	BOOL DataPut(BYTE *pSrcBuf, DWORD dwSrcSize);
	BOOL DataGet(BYTE **ppDstBuf, DWORD *pdwDstSize);
	BOOL DataFlush(BYTE **ppDstBuf, DWORD *pdwDstSize);

	BOOL Ext_GetB25Version(BYTE *pbyMajor,BYTE *pbyMinor,BYTE *pbyBuild);
	BOOL Ext_ProcEmm(BOOL bFlag);

protected:
	HMODULE		m_hLib;
	IB25Decoder *m_pDecorder;
	IB25DecoderEx *m_pDecorderEx;

	DWORD m_dwVer;
};
